
#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

void LCD12864_Init(void );
void LCD_ShowNum(unsigned char x,unsigned char y,unsigned int num,unsigned char len);
void LCD_ShowAnych(unsigned char row,unsigned char page ,unsigned char *dat);

void wt_com(unsigned char com)
{

{(*(unsigned char *) 0x62)&=~(1<<2);};
{(*(unsigned char *) 0x62)&=~(1<<1);};
{(*(unsigned char *) 0x62)&=~(1<<0);}; 
delay_ms(2);
PORTE=com;
delay_ms(5);
{(*(unsigned char *) 0x62)|=1<<0;};
delay_ms(2);
{(*(unsigned char *) 0x62)&=~(1<<0);};
}

void wt_dat(unsigned char dat)
{

{(*(unsigned char *) 0x62)|=1<<2;} ;
{(*(unsigned char *) 0x62)&=~(1<<1);};
{(*(unsigned char *) 0x62)&=~(1<<0);};
delay_ms(2);
PORTE=dat;
delay_ms(5);
{(*(unsigned char *) 0x62)|=1<<0;};
delay_ms(2);
{(*(unsigned char *) 0x62)&=~(1<<0);};
}

void lcd_clear(void )
{
wt_com(0x01);
delay_ms(5);
}

void LCD12864_Init(void )
{
(*(unsigned char *) 0x61)|=0X07;
DDRB|=0X07;
DDRE|=0XFF; 
delay_ms(100);    
{PORTB|=1<<0;} ;
{PORTB&=~(1<<2); };		 
delay_ms(3);                   
{PORTB|=1<<2;} ;      
delay_ms(3);
wt_com(0x34);      
delay_ms(5);
wt_com(0x30);      
delay_ms(5);
wt_com(0x0C);      
delay_ms(5);
wt_com(0x01);      
delay_ms(5);
lcd_clear();
}
void LCD_ShowAnych(unsigned char row,unsigned char page ,unsigned char *dat)
{
if(row==1)
wt_com(0x80+page);
else if(row==2)
wt_com(0x90+page);
else if(row==3)
wt_com(0x88+page);
else if(row==4)
wt_com(0x98+page);
while(*dat!='\0')
{

wt_dat(*dat);
*dat++; 
}
}

unsigned int mypow(unsigned char  m,unsigned char n)
{
unsigned int result=1;	 
while(n--)result*=m;    
return result;
}

void LCD_ShowNum(unsigned char x,unsigned char y,unsigned int num,unsigned char len)
{         	
unsigned char t;
unsigned int temp;
if(x==1)
wt_com(0x80+y);
else if(x==2)
wt_com(0x90+y);
else if(x==3)
wt_com(0x88+y);
else if(x==4)
wt_com(0x98+y);

for(t=0;t<len;t++)
{
temp=(num/mypow(10,len-t-1))%10;
wt_dat(temp+0x30); 
}
} 

